//+------------------------------------------------------------------+
//| ASCTrend1sig_noSound JStochastic.mq4
//| Ramdass - Conversion only
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Yellow

//---- input parameters
extern int RISK=3;
extern int CountBars=2000;
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;
extern int Phase  = 0; //  JMA ,    -100 ... +100,     ; 

extern double Nyquist=0.5;//apply Nyquist intervalls 1.5, 2, 2.5 etc.
extern int Input_Price_Customs = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
extern int degree=150;                 // Degree of autocorrelation for MESA (Maximum Entropy Spectrum Analysis)
extern int length=400;                 // Number of previous Bars to perform MESA calculation
extern double max_period=140;          // Upper bound for SATL cutoff period (1/frequency)
extern double min_period=20;           // Lower bound for FATL cutoff period
extern double satl_min_period=60.0;    // Lower bound for SATL (upper bound for FATL is 80% of "*")
extern datetime initial_time=D'2011.01.01 00:00'; // if backwardBars=0, get it from initial_time
extern int filterPersistenceBars=100;   // The SATL and FATL cutoff periods are re-calculated every "*" bars
extern int bkwdBars=100;             // The indicator is drawn backard "*" bars       ** Check if == 0 ** (MESA_Cutoff_frequencies problems??
extern int smoothed =0;
extern int buffer = 0;
//---- buffers
double val1[];
double val2[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,234);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,233);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| ASCTrend1sig                                                     |
//+------------------------------------------------------------------+
int start()
  {
   //if (CountBars>=1000) CountBars=950;
   SetIndexDrawBegin(0,Bars-CountBars+11+1);
   SetIndexDrawBegin(1,Bars-CountBars+11+1);
   int i,shift,counted_bars=IndicatorCounted();
   int Counter,i1,value10,value11;
   double value1,x1,x2;
   double value2,value3;
   double TrueCount,Range,AvgRange,MRO1,MRO2;
   double Table_value2[50000];
   
   value10=3+RISK*2;
   x1=67+RISK;
   x2=33-RISK;
   value11=value10;
//----
   if(Bars<=11+1) return(0);
//---- initial zero
   if(counted_bars<11+1)
   {
      for(i=1;i<=0;i++) val1[CountBars-i]=0.0;
      for(i=1;i<=0;i++) val2[CountBars-i]=0.0;
   }
//----

  shift=CountBars-11-1;
  while(shift>=0)
  {
    Counter=shift;
  	Range=0.0;
    AvgRange=0.0;
    for(Counter=shift; Counter<=shift+9; Counter++) AvgRange=AvgRange+MathAbs(High[Counter]-Low[Counter]);

    Range=AvgRange/10;
    Counter=shift;
    TrueCount=0;
    while (Counter<shift+9 && TrueCount<1)
		{
      if (MathAbs(Open[Counter]-Close[Counter+1])>=Range*2.0) TrueCount=TrueCount+1;
		  Counter=Counter+1;
		}
    if (TrueCount>=1) {MRO1=Counter;} else {MRO1=-1;}
    Counter=shift;
    TrueCount=0;
    while (Counter<shift+6 && TrueCount<1)
		{
		  if (MathAbs(Close[Counter+3]-Close[Counter])>=Range*4.6) TrueCount=TrueCount+1;
		  Counter=Counter+1;
		}
    if (TrueCount>=1) {MRO2=Counter;} else {MRO2=-1;}
    if (MRO1>-1) {value11=3;} else {value11=value10;}
    if (MRO2>-1) {value11=4;} else {value11=value10;}
    value2=iCustom(Symbol(),Period(),"JStochastic_MESA",KPeriod,DPeriod,Slowing,Phase,Nyquist,Input_Price_Customs,degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,bkwdBars,smoothed,buffer,shift); // PercentR(value11=9)
    Table_value2[shift]=value2;
    val1[shift]=0;
    val2[shift]=0;
    value3=0;
    if (value2<x2)
    {
      i1=1;
  		while (Table_value2[shift+i1]>=x2 && Table_value2[shift+i1]<=x1){i1++;}
  		if (Table_value2[shift+i1]>x1) 
      {
  			value3=High[shift]+Range*0.5;
        val1[shift]=value3;
      } 
    }
    if (value2>x1)
    {
      i1=1;
  		while (Table_value2[shift+i1]>=x2 && Table_value2[shift+i1]<=x1){i1++;}
  		if (Table_value2[shift+i1]<x2) 
  		{
  			value3=Low[shift]-Range*0.5;
  			val2[shift]=value3;
  		}
  	}
    shift--;
  }

  return(0);
}
//+------------------------------------------------------------------+


